//@author: vux
//@help: template for standard shaders
//@tags: template
//@credits: 

Texture2DMS<uint4> texture2dMS <string uiname="MS Texture";>;
Texture2D<uint4> texture2d <string uiname="Texture";>;
float scale;
uint sampleCount;

struct VS_IN
{
	float4 pos : POSITION;
	float4 uv : TEXCOORD0;

};

struct vs2ps
{
    float4 pos: SV_POSITION;
    float4 uv: TEXCOORD0;
};

vs2ps VS(VS_IN input)
{
    return input;
}



float4 PS_Load(vs2ps In): SV_Target
{
    float col = texture2d.Load(int3(In.pos.xy, 0), 0).g;
    return col*scale;
}

float4 PS_LoadMS(vs2ps In): SV_Target
{
    float col = texture2dMS.Load(In.pos.xy, 0).g;
    return col*scale;
}

float4 PS_LoadMS_Multi(vs2ps In): SV_Target
{
	float col = 0;
	for (uint i = 0; i<sampleCount; i++)
	{
    	col += texture2dMS.Load(In.pos.xy, i).g;
	}
	
	col /= sampleCount;
    return col*scale;
}

technique10 Load
{
	pass P0
	{
		SetVertexShader( CompileShader( vs_5_0, VS() ) );
		SetPixelShader( CompileShader( ps_5_0, PS_Load() ) );
	}
}

technique10 LoadMS_Single
{
	pass P0
	{
		SetVertexShader( CompileShader( vs_5_0, VS() ) );
		SetPixelShader( CompileShader( ps_5_0, PS_LoadMS() ) );
	}
}


technique10 LoadMS_Multi
{
	pass P0
	{
		SetVertexShader( CompileShader( vs_5_0, VS() ) );
		SetPixelShader( CompileShader( ps_5_0, PS_LoadMS_Multi() ) );
	}
}